#ifndef __SPI_H__
#define __SPI_H__

typedef enum
{
	SPI_DATA_8BIT,
	SPI_DATA_16BIT
}Spi_Data_Size_t;

typedef enum
{
	MODE0,
	MODE1,
	MODE2,
	MODE3
}Spi_Mode_t;	

#define Config_SPI_Master()	LPC_SPI->SPCR |= (1<<5)
#define Config_SPI_Slave()	LPC_SPI->SPCR &=~(1<<5)

#define Enable_SPI_Interrupt()	LPC_SPI->SPCR |= (1<<7)
#define Disable_SPI_Interrupt()	LPC_SPI->SPCR &=~(1<<7)

#define Update_SPI_CCR(value)	LPC_SPI->SPCCR = value;

#define Write_SPI_Data(data)	LPC_SPI->SPDR = data 
#define Read_SPI_Data					LPC_SPI->SPDR

#define Wait_SPI_Transfer()		while(!(LPC_SPI->SPSR & (1<<7)))
#define Read_SPI_Status()			LPC_SPI->SPSR & (1<<7)
	
#define Select_SPI_Slave()		Set_GPIO_LOW(0,16)
#define Deselect_SPI_Slave()	Set_GPIO_HIGH(0,16)

//Clear SPI interrupt 
#define Clear_SIF_Interrupt()			LPC_SPI->SPINT |=(1<<0)

void Set_SPI_Base_Config(void);
void Set_SPI_Core_Config(void);
void Init_SPI(void);
//uint8_t Set_SPI_Data_Transfer(int master_data);
uint8_t Set_SPI_Data_Transfer(void);
void Aux_to_Primary(void);

#endif
